#ifndef DATA_H
#define DATA_H

#include "type.h"

bool                irc_user_store  (void);
bool                irc_user_load   (void);
bool                irc_pass_store  (void);
bool                irc_pass_load   (void);
bool                irc_port_store  (void);
bool                irc_port_load   (void);
bool                pest_port_store (void);
bool                pest_port_load  (void);
bool                scram_pass_store(void);
bool                scram_pass_load (void);

bool                killfile_add    (char const *handle);
bool                killfile_del    (char const *handle);
handle_t           *killfile_lookup (char const *handle);
void                killfile_print  (void);
bool                killfile_load   (void);
bool                killfile_store  (void);

#endif
