#ifndef IRCD_H
#define IRCD_H

#include "type.h"
#include <stddef.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdarg.h>

void                ircd_init   (ircev_f func);
void                ircd_exit   (void);
void                ircd_ckill  (void);

void                ircd_tick   (void);

size_t              ircd_send   (char const *str,size_t len);
size_t              ircd_sendf  (char const *fmt,...);
size_t              ircd_vsendf (char const *fmt,va_list args);

uint32_t            ircd_getip  (void);

#endif

