#include "state.h"

char                data_path     [PATH_BUF]      =  DATA_PATH_DEF;
char                self_handle   [HANDLE_BUF]    =  "";
bool                running                       =  1;
bool                scram                         =  0;
uint64_t            mono_offset                   = -1;
char                log_path      [PATH_BUF]      =  LOG_PATH_DEF;
FILE               *log_fp                        =  0;
int                 rng_slow_fd                   = -1;
int                 rng_fast_fd                   = -1;

char                irc_chan      [IRC_CHAN_BUF]  =  "";
char                irc_host      [IRC_HOST_BUF]  =  "";
bool                irc_conned                    =  0;
bool                irc_usered                    =  0;
bool                irc_passed                    =  0;
bool                irc_nicked                    =  0;
bool                irc_joined                    =  0;
bool                irc_ready                     =  0;
char const         *irc_log_chan                  =  0;

int                 udp_fd                        = -1;
bool                udp_silent                    =  1;
tcpev_f             tcp_func                      =  0;
int                 tcp_listen_fd                 = -1;
int                 tcp_client_fd                 = -1;
uint32_t            tcp_client_ip                 =  0;
uint16_t            tcp_client_port               =  0;
bool                tcp_silent                    =  0;

ircev_f             ircd_func                     =  0;
uint32_t            ircd_src_ip                   =  0;
uint16_t            ircd_src_port                 =  0;
char                ircd_buf      [IRC_MSG_BUF]   = {0};
char               *ircd_buf_p                    =  ircd_buf;

uint64_t            con_stamp                     =  0;
uint64_t            rekey_last                    =  0;
uint64_t            ignore_next                   =  0;
uint64_t            banner_last                   =  0;
uint64_t            addrcast_last                 =  0;

getdata_t           gd            [GETDATA_MAX];
size_t              gd_cnt                        =  0;
uint64_t            gd_retry_last                 =  0;

hearsay_t           hs            [HEARSAY_MAX];
size_t              hs_cnt                        =  0;

pending_t           pen           [PENDING_MAX];
size_t              pen_cnt                       =  0;

//pesistent state
char                irc_user      [IRC_USER_BUF]  =  "";
uint8_t             irc_pass      [PASS_SIZE]     = {0};
uint16_t            irc_port                      =  IRC_PORT_DEF;
uint16_t            pest_port                     =  PEST_PORT_DEF;
uint8_t             scram_pass    [PASS_SIZE]     = {0};

bool                setport                       =  0;
int64_t             cutoff                        =  0;
int64_t             hstime                        =  0;
int64_t             gdtime                        =  0;
int64_t             gdatt                         =  0;
int64_t             gdint                         =  0;
bool                rkrecv                        =  0;
bool                rksend                        =  0;
int64_t             rktime                        =  0;
int64_t             rkint                         =  0;
int64_t             igint                         =  0;
char                banner        [BANNER_BUF]    = {0};
int64_t             baint                         =  0;
char                acaddr        [AT_BUF]        = {0};
int64_t             acint                         =  0;
int64_t             irctime                       =  0;
char                master        [HANDLE_BUF]    = {0};

peer_t              peer          [PEER_MAX];
size_t              peer_cnt                      =  0;
peerid_t            peer_id                       =  0;

handle_t            killfile      [KILLFILE_MAX];
size_t              killfile_cnt                  =  0;

mess_t              mess;
hash_t              self;
hash_t              net;

hash_t              dedup_h       [DEDUP_MAX];
uint64_t            dedup_t       [DEDUP_MAX];
uintptr_t           dedup_f                       =  0;
uintptr_t           dedup_b                       = -1;

