#ifndef UTIL_H
#define UTIL_H

#include "type.h"
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>
#include <assert.h>

bool                port_valid    (int64_t port);

bool                check_port    (int64_t port,char const *proto);
bool                check_irc_user(char const *user);

bool                handle_valid  (char const *handle);

void                fmt_peerhost  (char *buf,size_t buf_size,char const *handle);

void                fmt_handle_ext(char *buf,size_t buf_size,char const *speaker,handle_t *parens,size_t parens_cnt);

void                cpy_speaker   (char *buf,size_t buf_size,uint8_t const *m);
void                cpy_text      (char *buf,size_t buf_size,uint8_t const *m);

bool                index_shuffle (uint16_t *i,size_t n);

#endif
