#ifndef ADDR_H
#define ADDR_H

#include "type.h"
#include <stdint.h>
#include <stdbool.h>
#include <stddef.h>

bool                addr_valid    (addr_t *addr);
inline bool         addr_null     (addr_t const *addr);
inline bool         addr_equal    (addr_t const *a,addr_t const *b);

bool                addr_from_at  (addr_t *addr,char const *at);
void                at_from_addr  (char *at,size_t at_size,addr_t const *addr);

inline bool addr_null(addr_t const *addr){
  return addr->ip == 0;
}

inline bool addr_equal(addr_t const *a,addr_t const *b){
  return a->ip   == b->ip &&
         a->port == b->port;
}

#endif

