#include "serial.h"

#define __EXTERN_READWRITE(NAME_PFIX,TYPE,WIDTH)\
  extern void read_##NAME_PFIX##WIDTH (uint8_t const *buf,TYPE       *data);\
  extern void write_##NAME_PFIX##WIDTH(uint8_t       *buf,TYPE const *data);

#define _EXTERN_READWRITE(WIDTH)\
  __EXTERN_READWRITE(u,uint##WIDTH##_t,WIDTH)\

_EXTERN_READWRITE(8)
_EXTERN_READWRITE(16)
_EXTERN_READWRITE(32)
_EXTERN_READWRITE(64)

extern uint16_t     byteswap16(uint16_t n);
extern uint32_t     byteswap32(uint32_t n);
extern uint64_t     byteswap64(uint64_t n);

